/*
    Copyright (C) 2012 NewestTools.com(AlexLe)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef _GSERV_CLIENT_H_
#define _GSERV_CLIENT_H_

#include "vbox_hdrs.h"
#include <windows.h>


#define TIMEOUT_GS_SHOW_WAITDLG (1000*5)
#define TIMEOUT_GS_WAIT_FOR_GSERVER_RESPONSE (120*1000)

UINT
GetWaitForInputFirstClientId();

UINT
CallGuestServer(
     IN  ULONG ClientId,
     IN  PVOID pInputBuffer,
     IN  ULONG InputBufferSize,
     OUT PVOID *ppOutputBuffer,
     OUT  ULONG *pOutputBufferSize
     );

VOID
GS_FreeMem( PVOID pPtr );

UINT
GS_GetClipboardOwnerClientId();

BOOL
GSERVCLIENT_Handle_svcCall(
    PVBOXHGCMSVCHELPERS pHelpers,
    void *ptrUnk,
    VBOXHGCMCALLHANDLE callHandle,
    uint32_t u32ClientID,
    void *pvClient,
    uint32_t u32Function,
    uint32_t cParms,
    VBOXHGCMSVCPARM paParms[]
    );

VOID
GSERVCLIENT_Handle_svcDisconnect(
    void *pUnk1, 
    uint32_t u32ClientID, 
    void *pvClient
    );

VOID
GSERVCLIENT_Handle_svcSaveState(
    void *pvService, 
    uint32_t u32ClientID, 
    void *pvClient, 
    PSSMHANDLE pSSM
    );


VOID
GSERVCLIENT_Handle_svcLoadState(
    void *pvService, 
    uint32_t u32ClientID, 
    void *pvClient, 
    PSSMHANDLE pSSM
    );

VOID
GSERVCLIENT_Handle_svcConnect(
	void *pvService,
	uint32_t u32ClientID,
	void *pvClient
	);
	

VOID
CreateContextMenuCmdWorkerThread();


#endif //_GSERV_CLIENT_H_
