/*
    Copyright (C) 2012 NewestTools.com(AlexLe)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef _SECURE_FUNCS_H_
#define _SECURE_FUNCS_H_

#if defined(__GNUC__)

#define USE_INTERNAL_SECURE_FUNCS

#endif 


#if defined(USE_INTERNAL_SECURE_FUNCS)

#ifndef ARRAYSIZE

#define ARRAYSIZE(Arr) ( sizeof(Arr)/sizeof(Arr[0]) )

#endif



#ifndef _ERRCODE_DEFINED
#define _ERRCODE_DEFINED
    typedef int errno_t;
#define EINVAL 22
#define ERANGE 34

#define _TRUNCATE ((size_t)-1)

#endif 

errno_t 
strcpy_s(
   char *strDestination,
   size_t numberOfElements,
   const char *strSource 
   );

errno_t 
wcscpy_s(
   wchar_t *strDestination,
   size_t numberOfElements,
   const wchar_t *strSource 
    );

errno_t
strncat_s(
   char *strDest,
   size_t numberOfElements,
   const char *strSource,
   size_t count
   );

errno_t
wcsncat_s(
   wchar_t *strDest,
   size_t numberOfElements,
   const wchar_t *strSource,
   size_t count 
  );

int
_snprintf_s(
   char *buffer,
   size_t sizeOfBuffer,
   size_t count,
   const char *format,
   ...
   );

int 
_snwprintf_s(
   wchar_t *buffer,
   size_t sizeOfBuffer,
   size_t count,
   const wchar_t *format,
   ... 
   );

int 
_vsnprintf_s(
   char *buffer,
   size_t sizeOfBuffer,
   size_t count,
   const char *format,
   va_list argptr 
   );

int
_vsnwprintf_s(
   wchar_t *buffer,
   size_t sizeOfBuffer,
   size_t count,
   const wchar_t *format,
   va_list argptr 
    );


#endif //defined(USE_INTERNAL_SECURE_FUNCS)


#endif //_SECURE_FUNCS_H_

