/*
    Copyright (C) 2012 NewestTools.com(AlexLe)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef _WINTOOLS_H_
#define _WINTOOLS_H_

#include <windows.h>

#include <vector>
#include <string>
using namespace std;

typedef 
BOOL
(__stdcall *TEnumDirProcA)(
	PVOID pContext,
	LPCSTR lpszFileName,
	DWORD dwAttr,
	ULONG64 FileSize
	);

typedef 
BOOL
(__stdcall *TEnumDirProcW)(
	PVOID pContext,
	LPCWSTR lpszFileName,
	DWORD dwAttr,
	ULONG64 FileSize,
    FILETIME *pLastWriteTime
	);


BOOL
EnumerateDirectoriesA(
	LPCSTR lpszDir,
	PVOID pContext,
	TEnumDirProcA pfnCallback
	);

BOOL
EnumerateDirectoriesW(
	LPCWSTR lpszDir,
	PVOID pContext,
	TEnumDirProcW pfnCallback
	);


BOOLEAN
ClipboardGetCopiedFileList(
	vector<wstring> *pFileList
	);

wstring
GetBaseFileNameW(
	LPCWSTR lpszFileName
	);

BOOL
RecreatePathW(
    LPCWSTR lpszFileName
	);

BOOL
CreateFileWithRelPathW(
    HANDLE *pFileHandle,
    BOOL bOverWrite,
    wstring *pFileName,
	LPCWSTR pwszRootDir,
	LPCWSTR pwszRelPath,
	DWORD dwFileAttr
    );

wstring
GetFullPathFromRelative(
	LPCWSTR pwszRootDir,
	LPCWSTR pwszRelPath
    );


//COM should be initialized

wstring
COM_LnkToFilePathW(
    LPCWSTR lpszLnkFile
    );

BOOL
IsEqualFileExtW( LPCWSTR lpszFileName, LPCWSTR lpExt );

BOOLEAN
GetFileInfoW(
    LPCWSTR lpszFileName,
	UINT64 *FileSize,
	DWORD *pAttr,
    FILETIME *pFileLastWriteTime
	);

BOOL
OpenAppMutexAndCheckIsAppInstanceExist(
    LPCSTR lpAppMutexName
    );

VOID
CloseAppMutex();

BOOL
NotifyIcon_Add(
    HWND hWnd,
    ULONG uWindowMessage,
    HICON hIcon,
    LPCSTR lpszTip OPTIONAL
    );

BOOL
NotifyIcon_Delete(
    HWND hWnd
    );

string
GetCurrentProcessDirA();

string
GetCurrentProcessFileNameA();

string
GetCurrentProcessFullPathA();


BOOL
IsFileExistA( LPCSTR lpFileName );

BOOL
IsAdminGroupEnabled(
    BOOL *pEnabled
    );

HWND
FindFirstChildWindow( HWND hWnd );

wstring
GetDesktopFolder();

string
UnicodeToAnsi(
    const wstring &WideStr
    );

//return INVALID_HANDLE_VALUE if error
HANDLE
OpenDirW(
	LPCWSTR lpszDir,
	//FILE_LIST_DIRECTORY, FILE_WRITE_ATTRIBUTES
	DWORD dwAccess
	);

string
FileTimeToString( FILETIME *pFileTime );

VOID
GetDirFilesListW(
    LPCWSTR lpszDir,
    vector<wstring> *pFilesList
    );

BOOL
StringListToBuffW(
    vector<wstring> *pStrList,
    PVOID pBuff OPTIONAL,
    ULONG BuffSize,
    PULONG pRequiredBuffSize,
	PULONG pWritelnBytes
    );

BOOL
BuffToStringListW(
    vector<wstring> *pOutputStrList,
    PVOID pBuff,
    ULONG BuffSize // BuffSize should be equal to *pWritelnBytes
    );

	
HANDLE
CreateFileWithWriteAccessW(
	LPCWSTR lpszFileName,
	BOOL bOverWrite,
	DWORD dwFileAttr
	);

//__success(ret==0)
int
RemoveDirectoryRecursiveW(
	IN LPCWSTR lpszDirFullPath,
	IN LPCWSTR lpszTitle OPTIONAL,
	IN BOOL bSilent
	);

#endif //_WINTOOLS_H_

